#ifndef BAG_HPP
#define BAG_HPP

#include <cstddef>

// Linked list based bag after Sedgewick and Wayne, Algorithms 4th ed, Algorithm 1.2

template <typename T>
class Bag {

private:

    ////////////////////////////////////
    class Node {
    public:
        T item;
        Node *next;
        };


public:

    ////////////////////////////////////
    class iterator;
    friend class iterator;
    class iterator {

    public:

        iterator( Node *c );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename Bag<T>::iterator );

    private:

        Node *curr;
        };

    ////////////////////////////////////

    Bag( void );
    ~Bag( void );

    void add( T &item );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );

private:

    size_t N;
    Node *list;

    };



#endif

