#ifndef RESIZINGARRAYDEQUE_HPP
#define RESIZINGARRAYDEQUE_HPP

#include <cstddef>

template <typename T>
class ResizingArrayDeque {

public:

    ////////////////////////////////////////
    class iterator {

    public:

        iterator( T *c, T *l, T *b, T *m );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename ResizingArrayDeque<T>::iterator );

    private:

        T *curr;
        T *last;
        T *begin;
        T *max;
        };

    ////////////////////////////////////////
    ResizingArrayDeque( void );
    ~ResizingArrayDeque( void );

    void push_left( T &item );
    void push_right( T &item );
    T pop_left( void );
    T pop_right( void );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );

private:

    size_t N;
    size_t max;
    T *first, *last;
    T *data;

    void resize( size_t new_max );
    };



#endif

